package org.artifactory.layout;

import org.artifactory.addon.AddonsManager;
import org.artifactory.addon.xray.XrayAddon;
import org.artifactory.config.ConfigurationChangesInterceptor;
import org.artifactory.descriptor.config.CentralConfigDescriptor;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

@Component
public class XrayRepoIndexInterceptor implements ConfigurationChangesInterceptor {

    private static final Logger log = LoggerFactory.getLogger(XrayRepoIndexInterceptor.class);
    @Autowired
    AddonsManager addonsManager;

    public void onAfterSave(CentralConfigDescriptor newDescriptor, CentralConfigDescriptor oldDescriptor) {
        log.debug("Xray index interceptor is running");
        XrayAddon xrayAddon = addonsManager.addonByType(XrayAddon.class);
        if (xrayAddon.isXrayEnabled()) {
            log.debug("Xray enabled, searching for diff");
            xrayAddon.reportReposIndexDiff(newDescriptor, oldDescriptor);
        }
    }


}
