package org.artifactory.storage.binstore.service;

import org.artifactory.test.ArtifactoryHomeBoundTest;
import org.testng.Assert;
import org.testng.annotations.Test;

/**
 * @author Alexei Vainshtein
 */
public class GarbageCollectorInfoTest extends ArtifactoryHomeBoundTest {

    @Test
    public void setStatusTest() {
        GarbageCollectorInfo garbageCollectorInfo = new GarbageCollectorInfo(GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.UNCOMPLETED);
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.failures, 0);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.COMPLETED);
        garbageCollectorInfo.status = GarbageCollectListenerResultStatus.UNCOMPLETED;

        garbageCollectorInfo.candidatesForDeletion = 5;
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.COMPLETED);
        garbageCollectorInfo.status = GarbageCollectListenerResultStatus.UNCOMPLETED;

        garbageCollectorInfo.failures = 5;
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.failures = 6;
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.candidatesForDeletion = 25;
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.failures, 6);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.COMPLETED);
        garbageCollectorInfo.status = GarbageCollectListenerResultStatus.UNCOMPLETED;

        garbageCollectorInfo.failures = 10;
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.UNCOMPLETED);

        garbageCollectorInfo.failures = 11;
        garbageCollectorInfo.setStatus();
        Assert.assertEquals(garbageCollectorInfo.strategy, GarbageCollectorStrategy.FULL);
        Assert.assertEquals(garbageCollectorInfo.status, GarbageCollectListenerResultStatus.UNCOMPLETED);
    }
}
