package org.artifactory.rest.resource.projects;

import org.apache.http.HttpStatus;
import org.artifactory.api.security.AuthorizationService;
import org.jfrog.access.client.project.ProjectSlimEntity;
import org.springframework.beans.factory.config.BeanDefinition;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

import javax.annotation.security.RolesAllowed;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

/**
 * The resource is taking care on Access events related to projects
 *
 * @author BarakH
 */

@Component
@Scope(BeanDefinition.SCOPE_PROTOTYPE)
@Path("v1/projects")
@RolesAllowed({AuthorizationService.ROLE_ADMIN})
public class ProjectsResource {

    @PUT
    @Consumes(MediaType.APPLICATION_JSON)
    public Response onProjectCreated(ProjectSlimEntity project) {
        if (project == null) {
            return Response.status(HttpStatus.SC_BAD_REQUEST).build();
        }
        return Response.ok().build();
    }

    @DELETE
    @Consumes(MediaType.APPLICATION_JSON)
    public Response onProjectDeleted(ProjectSlimEntity project) {
        if (project == null) {
            return Response.status(HttpStatus.SC_BAD_REQUEST).build();
        }
        return Response.ok().build();
    }
}